void test()
{

    doing(1, "basic sanity checks");
    m(1, "&", "abc", "abc", "abc\0");
    f(2, "&", "abc", "def");
    m(3, "&", "abc", "xyabxabce", "abc\0");

    doing(2, "invalid option combinations");
    e(1, "qe", "a", REG_INVARG);
    e(2, "qa", "a", REG_INVARG);
    e(3, "qx", "a", REG_INVARG);
    e(4, "qn", "a", REG_INVARG);
    e(5, "ba", "a", REG_INVARG);

    doing(3, "basic syntax");
    m(2, "NS", "a|", "a", "a\0");
    m(3, "-", "a|b", "a", "a\0");
    m(4, "-", "a|b", "b", "b\0");
    m(5, "NS", "a||b", "b", "b\0");
    m(6, "&", "ab", "ab", "ab\0");

    doing(4, "parentheses");
    m(1, "-", "(a)e", "ae", "ae\0a\0");
    m(2, "o", "(a)e", "ae", "");
    m(3, "b", "\\(a\\)b", "ab", "ab\0a\0");
    m(4, "-", "a((b)c)", "abc", "abc\0bc\0b\0");
    m(5, "-", "a(b)(c)", "abc", "abc\0b\0c\0");
    e(6, "-", "a(b", REG_EPAREN);
    e(7, "b", "a\\(b", REG_EPAREN);
    m(8, "eU", "a)b", "a)b", "a)b\0");
    e(9, "-", "a)b", REG_EPAREN);
    e(10, "b", "a\\)b", REG_EPAREN);
    m(11, "P", "a(?:b)c", "abc", "abc\0");
    e(12, "e", "a(?:b)c", REG_BADRPT);
    m(14, "SP", "a(?:)b", "ab", "ab\0");
    m(16, "S", "a(b|)c", "abc", "abc\0b\0");

    doing(5, "simple one-char matching");
    m(1, "&", "a.b", "axb", "axb\0");
    f(2, "&n", "a.b", "a\nb");
    m(3, "&", "a[bc]d", "abd", "abd\0");
    m(4, "&", "a[bc]d", "acd", "acd\0");
    f(5, "&", "a[bc]d", "aed");
    f(6, "&", "a[^bc]d", "abd");
    m(7, "&", "a[^bc]d", "aed", "aed\0");
    f(8, "&p", "a[^bc]d", "a\nd");

    doing(6, "context-dependent syntax");
    e(1, "-", "*", REG_BADRPT);
    m(2, "b", "*", "*", "*\0");
    m(3, "b", "\\(*\\)", "*", "*\0*\0");
    e(4, "-", "(*)", REG_BADRPT);
    m(5, "b", "^*", "*", "*\0");
    e(6, "-", "^*", REG_BADRPT);
    f(7, "&", "^b", "^b");
    m(8, "b", "x^", "x^", "x^\0");
    f(9, "I", "x^", "x");
    m(10, "n", "\n^", "x\nb", "\n\0");
    f(11, "bS", "\\(^b\\)", "^b");
    m(12, "-", "(^b)", "b", "b\0b\0");
    m(13, "&", "x$", "x", "x\0");
    m(14, "bS", "\\(x$\\)", "x", "x\0x\0");
    m(15, "-", "(x$)", "x", "x\0x\0");
    m(16, "b", "x$y", "x$y", "x$y\0");
    f(17, "I", "x$y", "xy");
    m(18, "n", "x$\n", "x\n", "x\n\0");
    e(19, "-", "+", REG_BADRPT);
    e(20, "-", "?", REG_BADRPT);

    doing(7, "simple quantifiers");
    m(1, "&N", "a*", "aa", "aa\0");
    m(3, "-", "a+", "aa", "aa\0");
    m(4, "-", "a?b", "ab", "ab\0");
    m(5, "-", "a?b", "b", "b\0");
    e(6, "-", "**", REG_BADRPT);
    m(7, "bN", "**", "***", "***\0");
    e(8, "&", "a**", REG_BADRPT);
    e(9, "&", "a**b", REG_BADRPT);
    e(10, "&", "***", REG_BADRPT);
    e(11, "*", "a++", REG_BADRPT);
    e(12, "*", "a?+", REG_BADRPT);
    e(13, "*", "a?*", REG_BADRPT);
    e(14, "*", "a+*", REG_BADRPT);
    e(15, "*", "a*+", REG_BADRPT);

    doing(8, "braces");
    m(1, "NQ", "a{0,1}", "", "\0");
    m(2, "NQ", "a{0,1}", "ac", "a\0");
    e(3, "-", "a{1,0}", REG_BADBR);
    e(4, "-", "a{1,2,3}", REG_BADBR);
    e(5, "-", "a{257}", REG_BADBR);
    e(6, "-", "a{1000}", REG_BADBR);
    e(7, "-", "a{1", REG_EBRACE);
    e(8, "-", "a{1n}", REG_BADBR);
    m(9, "BS", "a{b", "a{b", "a{b\0");
    m(10, "BS", "a{", "a{", "a{\0");
    m(11, "bQ", "a\\{0,1\\}b", "cb", "b\0");
    e(12, "b", "a\\{0,1", REG_EBRACE);
    e(13, "-", "a{0,1\\", REG_BADBR);
    m(14, "Q", "a{0}b", "ab", "b\0");
    m(15, "Q", "a{0,0}b", "ab", "b\0");
    m(16, "Q", "a{0,1}b", "ab", "ab\0");
    m(17, "Q", "a{0,2}b", "b", "b\0");
    m(18, "Q", "a{0,2}b", "aab", "aab\0");
    m(19, "Q", "a{0,}b", "aab", "aab\0");
    m(20, "Q", "a{1,1}b", "aab", "ab\0");
    m(21, "Q", "a{1,3}b", "aaaab", "aaab\0");
    f(22, "Q", "a{1,3}b", "b");
    m(23, "Q", "a{1,}b", "aab", "aab\0");
    f(24, "Q", "a{2,3}b", "ab");
    m(25, "Q", "a{2,3}b", "aaaab", "aaab\0");
    f(26, "Q", "a{2,}b", "ab");
    m(27, "Q", "a{2,}b", "aaaab", "aaaab\0");

    doing(9, "brackets");
    m(1, "&", "a[bc]", "ac", "ac\0");
    m(2, "&", "a[-]", "a-", "a-\0");
    m(3, "&", "a[[.-.]]", "a-", "a-\0");
    m(4, "&L", "a[[.zero.]]", "a0", "a0\0");
    m(5, "&LM", "a[[.zero.]-9]", "a2", "a2\0");
    m(6, "&M", "a[0-[.9.]]", "a2", "a2\0");
    m(7, "&+L", "a[[=x=]]", "ax", "ax\0");
    m(8, "&+L", "a[[=x=]]", "ay", "ay\0");
    f(9, "&+L", "a[[=x=]]", "az");
    e(10, "&", "a[0-[=x=]]", REG_ERANGE);
    m(11, "&L", "a[[:digit:]]", "a0", "a0\0");
    e(12, "&", "a[[:woopsie:]]", REG_ECTYPE);
    f(13, "&L", "a[[:digit:]]", "ab");
    e(14, "&", "a[0-[:digit:]]", REG_ERANGE);
    m(15, "&LP", "[[:<:]]a", "a", "a\0");
    m(16, "&LP", "a[[:>:]]", "a", "a\0");
    e(17, "&", "a[[..]]b", REG_ECOLLATE);
    e(18, "&", "a[[==]]b", REG_ECOLLATE);
    e(19, "&", "a[[::]]b", REG_ECTYPE);
    e(20, "&", "a[[.a", REG_EBRACK);
    e(21, "&", "a[[=a", REG_EBRACK);
    e(22, "&", "a[[:a", REG_EBRACK);
    e(23, "&", "a[", REG_EBRACK);
    e(24, "&", "a[b", REG_EBRACK);
    e(25, "&", "a[b-", REG_EBRACK);
    e(26, "&", "a[b-c", REG_EBRACK);
    m(27, "&M", "a[b-c]", "ab", "ab\0");
    m(28, "&", "a[b-b]", "ab", "ab\0");
    m(29, "&M", "a[1-2]", "a2", "a2\0");
    e(30, "&", "a[c-b]", REG_ERANGE);
    e(31, "&", "a[a-b-c]", REG_ERANGE);
    m(32, "&M", "a[--?]b", "a?b", "a?b\0");
    m(33, "&", "a[---]b", "a-b", "a-b\0");
    m(34, "&", "a[]b]c", "a]c", "a]c\0");
    m(35, "EP", "a[\\]]b", "a]b", "a]b\0");
    f(36, "bE", "a[\\]]b", "a]b");
    m(37, "bE", "a[\\]]b", "a\\]b", "a\\]b\0");
    m(38, "eE", "a[\\]]b", "a\\]b", "a\\]b\0");
    m(39, "EP", "a[\\\\]b", "a\\b", "a\\b\0");
    m(40, "eE", "a[\\\\]b", "a\\b", "a\\b\0");
    m(41, "bE", "a[\\\\]b", "a\\b", "a\\b\0");
    e(42, "-", "a[\\Z]b", REG_EESCAPE);
    m(43, "&", "a[[b]c", "a[c", "a[c\0");

    doing(10, "anchors and newlines");
    m(1, "&", "^a", "a", "a\0");
    f(2, "&^", "^a", "a");
    f(5, "&$", "a$", "a");
    m(7, "&n", "^a", "a", "a\0");
    m(8, "&n", "^a", "b\na", "a\0");
    m(11, "&n", "a$", "a", "a\0");
    m(12, "&n", "a$", "a\nb", "a\0");
    m(15, "b", "^^", "^", "^\0");
    m(17, "b", "$$", "$", "$\0");
    m(18, "&N", "^$", "", "\0");
    f(19, "&N", "^$", "a");
    m(21, "N", "$^", "", "\0");
    m(22, "b", "$^", "$^", "$^\0");
    m(23, "P", "\\Aa", "a", "a\0");
    m(24, "^P", "\\Aa", "a", "a\0");
    f(25, "^nP", "\\Aa", "b\na");
    m(26, "P", "a\\Z", "a", "a\0");
    m(27, "$P", "a\\Z", "a", "a\0");
    f(28, "$nP", "a\\Z", "a\nb");
    e(29, "-", "^*", REG_BADRPT);
    e(30, "-", "$*", REG_BADRPT);
    e(31, "-", "\\A*", REG_BADRPT);
    e(32, "-", "\\Z*", REG_BADRPT);

    doing(11, "boundary constraints");
    m(1, "&LP", "[[:<:]]a", "a", "a\0");
    m(2, "&LP", "[[:<:]]a", "-a", "a\0");
    f(3, "&LP", "[[:<:]]a", "ba");
    m(4, "&LP", "a[[:>:]]", "a", "a\0");
    m(5, "&LP", "a[[:>:]]", "a-", "a\0");
    f(6, "&LP", "a[[:>:]]", "ab");
    m(7, "bLP", "\\<a", "a", "a\0");
    f(8, "bLP", "\\<a", "ba");
    m(9, "bLP", "a\\>", "a", "a\0");
    f(10, "bLP", "a\\>", "ab");
    m(11, "LP", "\\ya", "a", "a\0");
    f(12, "LP", "\\ya", "ba");
    m(13, "LP", "a\\y", "a", "a\0");
    f(14, "LP", "a\\y", "ab");
    m(15, "LP", "a\\Y", "ab", "a\0");
    f(16, "LP", "a\\Y", "a-");
    f(17, "LP", "a\\Y", "a");
    f(18, "LP", "-\\Y", "-a");
    m(19, "LP", "-\\Y", "-%", "-\0");
    f(20, "LP", "\\Y-", "a-");
    e(21, "-", "[[:<:]]*", REG_BADRPT);
    e(22, "-", "[[:>:]]*", REG_BADRPT);
    e(23, "b", "\\<*", REG_BADRPT);
    e(24, "b", "\\>*", REG_BADRPT);
    e(25, "-", "\\y*", REG_BADRPT);
    e(26, "-", "\\Y*", REG_BADRPT);
    m(27, "LP", "\\ma", "a", "a\0");
    f(28, "LP", "\\ma", "ba");
    m(29, "LP", "a\\M", "a", "a\0");
    f(30, "LP", "a\\M", "ab");
    f(31, "ILP", "\\Ma", "a");
    f(32, "ILP", "a\\m", "a");

    doing(12, "character classes");
    m(1, "LP", "a\\db", "a0b", "a0b\0");
    f(2, "LP", "a\\db", "axb");
    f(3, "LP", "a\\Db", "a0b");
    m(4, "LP", "a\\Db", "axb", "axb\0");
    m(5, "LP", "a\\sb", "a b", "a b\0");
    m(6, "LP", "a\\sb", "a	b", "a	b\0");
    m(7, "LP", "a\\sb", "a\nb", "a\nb\0");
    f(8, "LP", "a\\sb", "axb");
    m(9, "LP", "a\\Sb", "axb", "axb\0");
    f(10, "LP", "a\\Sb", "a b");
    m(11, "LP", "a\\wb", "axb", "axb\0");
    f(12, "LP", "a\\wb", "a-b");
    f(13, "LP", "a\\Wb", "axb");
    m(14, "LP", "a\\Wb", "a-b", "a-b\0");
    m(15, "LP", "\\y\\w+z\\y", "adze-guz", "guz\0");
    m(16, "LPE", "a[\\d]b", "a1b", "a1b\0");
    m(17, "LPE", "a[\\s]b", "a b", "a b\0");
    m(18, "LPE", "a[\\w]b", "axb", "axb\0");

    doing(13, "escapes");
    e(1, "&", "a\\", REG_EESCAPE);
    m(2, "-", "a\\<b", "a<b", "a<b\0");
    m(3, "e", "a\\<b", "a<b", "a<b\0");
    m(4, "bAS", "a\\wb", "awb", "awb\0");
    m(5, "eAS", "a\\wb", "awb", "awb\0");
    m(6, "PL", "a\\ab", "ab", "ab\0");
    m(7, "P", "a\\bb", "ab", "ab\0");
    m(8, "P", "a\\Bb", "a\\b", "a\\b\0");
    m(9, "MP", "a\\chb", "ab", "ab\0");
    m(10, "MP", "a\\cHb", "ab", "ab\0");
    m(11, "LMP", "a\\e", "a", "a\0");
    m(12, "P", "a\\fb", "ab", "ab\0");
    m(13, "P", "a\\nb", "a\nb", "a\nb\0");
    m(14, "P", "a\\rb", "a\rb", "a\rb\0");
    m(15, "P", "a\\tb", "a	b", "a	b\0");
    m(16, "P", "a\\u0008x", "ax", "ax\0");
    e(17, "-", "a\\u008x", REG_EESCAPE);
    m(18, "P", "a\\u00088x", "a8x", "a8x\0");
    m(19, "P", "a\\U00000008x", "ax", "ax\0");
    e(20, "-", "a\\U0000008x", REG_EESCAPE);
    m(21, "P", "a\\vb", "ab", "ab\0");
    m(22, "MP", "a\\x08x", "ax", "ax\0");
    e(23, "-", "a\\xq", REG_EESCAPE);
    m(24, "MP", "a\\x0008x", "ax", "ax\0");
    e(25, "-", "a\\z", REG_EESCAPE);
    m(26, "MP", "a\\010b", "ab", "ab\0");

    doing(14, "back references");
    m(1, "R[1P", "a(b*)c\\1", "abbcbb", "abbcbb\0bb\0");
    m(2, "R[1P", "a(b*)c\\1", "ac", "ac\0\0");
    f(3, "R[1P", "a(b*)c\\1", "abbcb");
    m(4, "R[1P", "a(b*)\\1", "abbcbb", "abb\0b\0");
    m(5, "R[1P", "a(b|bb)\\1", "abbcbb", "abb\0b\0");
    m(6, "R[1P", "a([bc])\\1", "abb", "abb\0b\0");
    f(7, "R[1P", "a([bc])\\1", "abc");
    m(8, "R[1P", "a([bc])\\1", "abcabb", "abb\0b\0");
    f(9, "R[1P", "a([bc])*\\1", "abc");
    f(10, "R[1P", "a([bc])\\1", "abB");
    m(11, "iR[1P", "a([bc])\\1", "abB", "abB\0b\0");
    m(12, "R[1P", "a([bc])\\1+", "abbb", "abbb\0b\0");
    m(13, "QR[1P", "a([bc])\\1{3,4}", "abbbb", "abbbb\0b\0");
    f(14, "QR[1P", "a([bc])\\1{3,4}", "abbb");
    m(15, "R[1P", "a([bc])\\1*", "abbb", "abbb\0b\0");
    m(16, "R[1P", "a([bc])\\1*", "ab", "ab\0b\0");
    m(17, "R[2P", "a([bc])(\\1*)", "ab", "ab\0b\0\0");
    e(18, "-", "a((b)\\1)", REG_ESUBREG);
    e(19, "-", "a(b)c\\2", REG_ESUBREG);
    m(20, "bR[1", "a\\(b*\\)c\\1", "abbcbb", "abbcbb\0bb\0");

    doing(15, "octal escapes vs back references");
    m(1, "MP", "a\\010b", "ab", "ab\0");
    m(2, "MP", "a\\0070b", "a0b", "a0b\0");
    m(3, "MP", "a\\07b", "ab", "ab\0");
    m(4, "MP", "a(b)(b)(b)(b)(b)(b)(b)(b)(b)(b)\\07c", "abbbbbbbbbbc", "abbbbbbbbbbc\0b\0b\0b\0b\0b\0b\0b\0b\0b\0b\0");
    e(5, "-", "a\\7b", REG_ESUBREG);
    m(6, "MP", "a\\10b", "ab", "ab\0");
    m(7, "MP", "a\\101b", "aAb", "aAb\0");
    m(8, "RP", "a(b)(b)(b)(b)(b)(b)(b)(b)(b)(b)\\10c", "abbbbbbbbbbbc", "abbbbbbbbbbbc\0b\0b\0b\0b\0b\0b\0b\0b\0b\0b\0");
    e(9, "-", "a((((((((((b\\10))))))))))c", REG_ESUBREG);
    m(10, "MP", "a\\12b", "a\nb", "a\nb\0");
    e(11, "b", "a\\12b", REG_ESUBREG);
    m(12, "eAS", "a\\12b", "a12b", "a12b\0");

    doing(16, "expanded syntax");
    m(1, "xP", "a b c", "abc", "abc\0");
    m(2, "xP", "a b #oops\nc	d", "abcd", "abcd\0");
    m(3, "x", "a\\ b\\	c", "a b	c", "a b	c\0");
    m(4, "xP", "a b\\#c", "ab#c", "ab#c\0");
    m(5, "xP", "a b[c d]e", "ab e", "ab e\0");
    m(6, "xP", "a b[c#d]e", "ab#e", "ab#e\0");
    m(7, "xP", "a b[c#d]e", "abde", "abde\0");
    m(8, "xSPB", "ab{ d", "ab{d", "ab{d\0");
    m(9, "xPQ", "ab{ 1 , 2 }c", "abc", "abc\0");

    doing(17, "misc syntax");
    m(1, "P", "a(?#comment)b", "ab", "ab\0");

    doing(18, "unmatchable REs");
    f(1, "I", "a^b", "ab");

    doing(19, "case independence");
    m(1, "&i", "ab", "Ab", "Ab\0");
    m(2, "&i", "a[bc]", "aC", "aC\0");
    f(3, "&i", "a[^bc]", "aB");
    m(4, "&iM", "a[b-d]", "aC", "aC\0");
    f(5, "&iM", "a[^b-d]", "aC");

    doing(20, "directors and embedded options");
    e(1, "&", "***?", REG_BADPAT);
    m(2, "q", "***?", "***?", "***?\0");
    m(3, "&P", "***=a*b", "a*b", "a*b\0");
    m(4, "q", "***=a*b", "***=a*b", "***=a*b\0");
    m(5, "bLP", "***:\\w+", "ab", "ab\0");
    m(6, "eLP", "***:\\w+", "ab", "ab\0");
    e(7, "&", "***:***=a*b", REG_BADRPT);
    m(8, "&P", "***:(?b)a+b", "a+b", "a+b\0");
    m(9, "P", "(?b)a+b", "a+b", "a+b\0");
    e(10, "e", "(?b)\\w+", REG_BADRPT);
    m(11, "bAS", "(?b)\\w+", "(?b)w+", "(?b)w+\0");
    m(12, "iP", "(?c)a", "a", "a\0");
    f(13, "iP", "(?c)a", "A");
    m(14, "APS", "(?e)\\W+", "WW", "WW\0");
    m(15, "P", "(?i)a+", "Aa", "Aa\0");
    f(16, "P", "(?m)a.b", "a\nb");
    m(17, "P", "(?m)^b", "a\nb", "b\0");
    f(18, "P", "(?n)a.b", "a\nb");
    m(19, "P", "(?n)^b", "a\nb", "b\0");
    f(20, "P", "(?p)a.b", "a\nb");
    f(21, "P", "(?p)^b", "a\nb");
    m(22, "P", "(?q)a+b", "a+b", "a+b\0");
    m(23, "nP", "(?s)a.b", "a\nb", "a\nb\0");
    m(24, "xP", "(?t)a b", "a b", "a b\0");
    m(25, "P", "(?w)a.b", "a\nb", "a\nb\0");
    m(26, "P", "(?w)^b", "a\nb", "b\0");
    m(27, "P", "(?x)a b", "ab", "ab\0");
    e(28, "-", "(?z)ab", REG_BADOPT);
    m(29, "P", "(?ici)a+", "Aa", "Aa\0");
    e(30, "P", "(?i)(?q)a+", REG_BADRPT);
    m(31, "P", "(?q)(?i)a+", "(?i)a+", "(?i)a+\0");
    m(32, "P", "(?qe)a+", "a", "a\0");
    m(33, "xP", "(?q)a b", "a b", "a b\0");
    m(34, "P", "(?qx)a b", "a b", "a b\0");
    m(35, "P", "(?qi)ab", "Ab", "Ab\0");

    doing(21, "capturing");
    m(1, "-", "a(b)c", "abc", "abc\0b\0");
    m(2, "P", "a(?:b)c", "xabc", "abc\0");
    m(3, "-", "a((b))c", "xabcy", "abc\0b\0b\0");
    m(4, "P", "a(?:(b))c", "abcy", "abc\0b\0");
    m(5, "P", "a((?:b))c", "abc", "abc\0b\0");
    m(6, "P", "a(?:(?:b))c", "abc", "abc\0");
    m(8, "-", "a(b)c(d)e", "abcde", "abcde\0b\0d\0");
    m(9, "-", "(b)c(d)e", "bcde", "bcde\0b\0d\0");
    m(10, "-", "a(b)(d)e", "abde", "abde\0b\0d\0");
    m(11, "-", "a(b)c(d)", "abcd", "abcd\0b\0d\0");
    m(12, "-", "(ab)(cd)", "xabcdy", "abcd\0ab\0cd\0");
    m(13, "-", "a(b)?c", "xabcy", "abc\0b\0");
    m(15, "-", "a(b)?c(d)?e", "xabcdey", "abcde\0b\0d\0");
    m(19, "-", "a(b)*c", "xabcy", "abc\0b\0");
    m(22, "-", "a(b*)c", "xabbbcy", "abbbc\0bbb\0");
    m(23, "-", "a(b*)c", "xacy", "ac\0\0");
    f(24, "-", "a(b)+c", "xacy");
    m(25, "-", "a(b)+c", "xabcy", "abc\0b\0");
    m(27, "-", "a(b+)c", "xabbbcy", "abbbc\0bbb\0");
    f(30, "Q", "a(b){2,3}c", "xabcy");
    m(31, "LP", "\\y(\\w+)\\y", "-- abc-", "abc\0abc\0");
    m(32, "-", "a((b|c)d+)+", "abacdbd", "acdbd\0bd\0b\0");
    m(33, "N", "(.*).*", "abc", "abc\0abc\0");
    m(34, "N", "(a*)*", "bc", "\0\0");

    doing(22, "multicharacter collating elements");

    doing(23, "lookahead constraints");
    m(1, "HP", "a(?=b)b*", "ab", "ab\0");
    f(2, "HP", "a(?=b)b*", "a");
    m(3, "HP", "a(?=b)b*(?=c)c*", "abc", "abc\0");
    f(4, "HP", "a(?=b)b*(?=c)c*", "ab");
    f(5, "HP", "a(?!b)b*", "ab");
    m(6, "HP", "a(?!b)b*", "a", "a\0");
    m(7, "HP", "(?=b)b", "b", "b\0");
    f(8, "HP", "(?=b)b", "a");

    doing(24, "non-greedy quantifiers");
    m(1, "P", "ab+?", "abb", "ab\0");
    m(2, "P", "ab+?c", "abbc", "abbc\0");
    m(3, "P", "ab*?", "abb", "a\0");
    m(4, "P", "ab*?c", "abbc", "abbc\0");
    m(5, "P", "ab??", "ab", "a\0");
    m(6, "P", "ab??c", "abc", "abc\0");
    m(7, "PQ", "ab{2,4}?", "abbbb", "abb\0");
    m(8, "PQ", "ab{2,4}?c", "abbbbc", "abbbbc\0");
    m(9, "-", "3z*", "123zzzz456", "3zzzz\0");
    m(10, "P", "3z*?", "123zzzz456", "3\0");
    m(11, "-", "z*4", "123zzzz456", "zzzz4\0");
    m(12, "P", "z*?4", "123zzzz456", "zzzz4\0");

    doing(25, "mixed quantifiers");
    m(1, "PN", "^(.*?)(a*)$", "xyza", "xyza\0xyz\0a\0");
    m(2, "PN", "^(.*?)(a*)$", "xyzaa", "xyzaa\0xyz\0aa\0");
    m(3, "PN", "^(.*?)(a*)$", "xyz", "xyz\0xyz\0\0");

    doing(26, "tricky cases");
    m(1, "-", "(week|wee)(night|knights)", "weeknights", "weeknights\0wee\0knights\0");
    m(2, "RP", "a(bc*).*\\1", "abccbccb", "abccbccb\0b\0");
    m(3, "-", "a(b.[bc]*)+", "abcbd", "abcbd\0bd\0");

    doing(27, "implementation misc.");
    m(1, "P", "a(?:b|b)c", "abc", "abc\0");
    m(2, "&", "[ab][ab][ab]", "aba", "aba\0");
    m(3, "&", "[ab][ab][ab][ab][ab][ab][ab]", "abababa", "abababa\0");

    doing(28, "boundary busters etc.");
    m(1, "&", "abcdefghijkl", "abcdefghijkl", "abcdefghijkl\0");
    m(2, "P", "a(?:b|c|d|e|f|g|h|i|j|k|l|m)n", "agn", "agn\0");
    m(3, "-", "a(((((((((((((b)))))))))))))c", "abc", "abc\0b\0b\0b\0b\0b\0b\0b\0b\0b\0b\0b\0b\0b\0");
    m(4, "Q", "ab{1,100}c", "abbc", "abbc\0");
    m(5, "Q", "ab{1,100}c", "abbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbc", "abbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbc\0");
    m(6, "Q", "ab{1,100}c", "abbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbc", "abbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbc\0");
    m(7, "LP", "\\w+abcdefgh", "xyzabcdefgh", "xyzabcdefgh\0");
    m(8, "%LP", "\\w+abcdefgh", "xyzabcdefgh", "xyzabcdefgh\0");
    m(9, "%LP", "\\w+abcdefghijklmnopqrst", "xyzabcdefghijklmnopqrst", "xyzabcdefghijklmnopqrst\0");

    doing(29, "incomplete matches");

    doing(30, "misc. oddities and old bugs");
    e(1, "&", "***", REG_BADRPT);
    m(2, "N", "a?b*", "abb", "abb\0");
    m(3, "N", "a?b*", "bb", "bb\0");
    m(4, "&", "a*b", "aab", "aab\0");
    m(5, "&", "^a*b", "aaaab", "aaaab\0");
    m(6, "&M", "[0-6][1-2][0-3][0-6][1-6][0-6]", "010010", "010010\0");
    m(7, "s", "abc", "abcd", "abc\0");
    f(8, "s", "abc", "xabcd");
    m(9, "HLP", "(?n)^(?![t#])\\S+", "tk\n\n#\n#\nit0", "it0\0");
}
